// ==========================================================================
// $Id: RgbeReader.cpp,v 1.1 2009/10/20 01:54:18 jaroslav Exp $
//
// @brief  Reader for Ward's RGBE format
// @author Jaroslav Krivanek 
// @date   January 2009

#include "RgbeReader.h"
extern "C" {
#include "rgbe.h"
};

int 
RgbeReader::read(const char* filename, int &outWidth, int &outHeight, float **outData)
{
  FILE *infp;

  if (!(infp = fopen(filename, "rb")))
    return -1; // error

  if( RGBE_ReadHeader(infp, &outWidth, &outHeight, NULL) == RGBE_RETURN_FAILURE)
  { fclose(infp); return -1; }

  *outData = new float[outWidth * outHeight * 3];

  if( RGBE_ReadPixels(infp, *outData, outWidth * outHeight) == RGBE_RETURN_FAILURE)
  { delete [] *outData; *outData = NULL; fclose(infp); return -1; }

  fclose(infp);
  return 0;
}
