#pragma once

class RgbeWriter
{
public:
	/// input float array contains RGB triples
	static void writeFromRgb(const char* file, int width, int height, float* data)
	{ writeFloatRgbBuffer(file, width, height, data, 3*sizeof(float)); }

	/// input float array contains RGBA quadruples, alpha is ignored
	static void writeFromRgba(const char *file, int width, int height, float *data)
	{ writeFloatRgbBuffer(file, width, height, data, 4*sizeof(float)); }

	/// input array contains float RGB triples, stride is in bytes
	static void writeFloatRgbBuffer(const char *file, int width, int height, float *data, int stride);

	/// input array contains RGBE values, stride is in bytes
	static void writeRgbeBuffer(const char *file, int width, int height, unsigned int *data, int stride);
};
